process Itpc_image (x,y,z,file,graph,size)
begin
    signal(id,s_freeze);
    frame;
end


process Ip_counting_game (int tcg_tiempo)
private
    int tcg_graf_numeros;
    int tgc_graf_sombras_numeros;
    int tgc_graf_interfaz;
    int tgc_ant_segundo;
    
    int tgc_text_map;
    int tgc_text_map_graph;
    
    int hijo_cronometro;
    int hijo_contador;
    int hijo_sonido_reloj;
    int hijos_interfaz[3];
    int hijos_mensajes[1];
    int hijos_temp[2];
    
    int cont_sonidos;
    int temp;
    int temp_graph[2];
begin
    //Carga de recursos
    tcg_graf_numeros=load_fpg("grafs/numbers.fpg");
    tgc_graf_sombras_numeros=load_fpg("grafs/s_numbers.fpg");
    tgc_graf_interfaz=load_fpg("grafs/count_interface.fpg");
    //Elementos de pantalla
    hijo_cronometro=crear_cronometro(tcg_graf_numeros,tgc_graf_sombras_numeros, 160-78, 0, 0, tcg_tiempo, 0);
    hijo_contador=contador_pulsaciones(22, 40, 0, tcg_graf_numeros,tgc_graf_sombras_numeros, 400,
                                       _KEY_1, &temp);
    hijos_interfaz[1]=sombra_fija( 23,175,1,tgc_graf_interfaz,2);
    hijos_interfaz[2]=sombra_fija(115,175,1,tgc_graf_interfaz,4);
    hijos_interfaz[3]=sombra_fija(208,175,1,tgc_graf_interfaz,6);
    switch (OS_ID)
    case 7,8,9:   //GP2X, WIZ, CAANOO
        set_text_color(rgb(0,64,21));
        tgc_text_map=write_in_map(0,"Press A as fast as you can",7);
        set_text_color(rgb(170,225,190));
        tgc_text_map_graph=write_in_map(0,"Press A as fast as you can",7);
    end
    default:    //PC
        set_text_color(rgb(0,64,21));
        tgc_text_map=write_in_map(0,"Press LEFT CURSOR as fast as you can",7);
        set_text_color(rgb(170,225,190));
        tgc_text_map_graph=write_in_map(0,"Press LEFT CURSOR as fast as you can",7);
    end
    end //switch
    hijos_mensajes[0]=Itpc_image(160,235,0,0,tgc_text_map,100);
    hijos_mensajes[1]=sombra_fija(160,235,1,0,tgc_text_map_graph);
    
    //Compas de espera
    canal_short_alarm=play_wav(sonido_short_alarm,0);
    frame(7500);
    hijos_interfaz[0]=Itpc_image(23,175,0,tgc_graf_interfaz,1,100);
    canal_short_alarm=play_wav(sonido_short_alarm,0);
    frame(7500);
    hijos_interfaz[0].x=115;
    hijos_interfaz[0].graph=3;
    canal_short_alarm=play_wav(sonido_short_alarm,0);
    frame(7500);
    hijos_interfaz[0].x=208;
    hijos_interfaz[0].graph=5;
    canal_long_alarm=play_wav(sonido_long_alarm,0);
    frame(10000);
    if (exists(hijos_interfaz[0])) signal(hijos_interfaz[0],s_kill); end
    
    //Adelante!!!!
    hijo_sonido_reloj=lcd_cronometro_sound();
    reloj_data.run=true;
    run_contar=true;
    while (!reloj_data.end_count)
        frame;
    end
    run_contar=false;
    
    //Fin de la partida
    unload_map(0,tgc_text_map);
    unload_map(0,tgc_text_map_graph);
    switch (OS_ID)
    case 7,8,9:   //GP2X, WIZ, CAANOO
        set_text_color(rgb(0,64,21));
        tgc_text_map=write_in_map(0,"Press SELECT to exit",7);
        set_text_color(rgb(170,225,190));
        tgc_text_map_graph=write_in_map(0,"Press SELECT to exit",7);
    end
    default:    //PC
        set_text_color(rgb(0,64,21));
        tgc_text_map=write_in_map(0,"Press ENTER to exit",7);
        set_text_color(rgb(170,225,190));
        tgc_text_map_graph=write_in_map(0,"Press ENTER to exit",7);
    end
    end //switch
    hijos_mensajes[0].graph=tgc_text_map;
    hijos_mensajes[1].graph=tgc_text_map_graph;
    //Parpadeo de los puntos
    hijos_temp[0]=get_id(type cp_digit);
    hijos_temp[1]=get_id(type cp_digit);
    hijos_temp[2]=get_id(type cp_digit);
    temp_graph[0]=hijos_temp[0].graph;
    temp_graph[1]=hijos_temp[1].graph;
    temp_graph[2]=hijos_temp[2].graph;
    canal_long_alarm=play_wav(sonido_long_alarm,0);
    cont_sonidos=0;
    while (teclas[_KEY_INTRO] != 1)
        if (tgc_ant_segundo != rtc_reloj.ss2)
            if (hijos_temp[0].graph==0)
                hijos_temp[0].graph=temp_graph[0];
                hijos_temp[1].graph=temp_graph[1];
                hijos_temp[2].graph=temp_graph[2];
                hijos_mensajes[0].graph=tgc_text_map;
                if (cont_sonidos < 3)
                    canal_long_alarm=play_wav(sonido_long_alarm,0);
                    cont_sonidos++;
                end
            else
                hijos_temp[0].graph=0;
                hijos_temp[1].graph=0;
                hijos_temp[2].graph=0;
                hijos_mensajes[0].graph=0;
            end
            tgc_ant_segundo=rtc_reloj.ss2;
        end
        frame;
    end
    
    //Descarga de recursos
    if (exists(hijo_cronometro)) signal(hijo_cronometro,s_kill_tree); end
    if (exists(hijo_contador)) signal(hijo_contador,s_kill_tree); end
    if (exists(hijo_sonido_reloj)) signal(hijo_sonido_reloj,s_kill); end
    if (exists(hijos_interfaz[1])) signal(hijos_interfaz[1],s_kill); end
    if (exists(hijos_interfaz[2])) signal(hijos_interfaz[2],s_kill); end
    if (exists(hijos_interfaz[3])) signal(hijos_interfaz[3],s_kill); end
    if (exists(hijos_mensajes[0])) signal(hijos_mensajes[0],s_kill); end
    if (exists(hijos_mensajes[1])) signal(hijos_mensajes[1],s_kill); end
    
    unload_fpg(tcg_graf_numeros);
    unload_fpg(tgc_graf_sombras_numeros);
    unload_fpg(tgc_graf_interfaz);
    unload_map(0,tgc_text_map);
    unload_map(0,tgc_text_map_graph);
    
    signal (father,s_wakeup);
    frame;
end
